function y=allpassq(x,Q)
%A 3rd order allpass filter
if ~isstruct(Q), error('Q is not a structure'), end
b0=roundq(0.7,Q); b1=roundq(0.19,Q); b2=roundq(-0.28,Q); b3=1;
a3=roundq(0.7,Q); a2=roundq(0.19,Q); a1=roundq(-0.28,Q); a0=1;
m1=0; m2=0; m3=0;
for i=1:length(x)
	xar=roundq(roundq(roundq(roundq(x(i),Q)-roundq(a1*m1,Q),Q)-roundq(a2*m2,Q),Q)-roundq(a3*m3,Q),Q);
	y(i)=roundq(roundq(roundq(roundq(b0*xar,Q)+roundq(b1*m1,Q),Q)+roundq(b2*m2,Q),Q)+roundq(b3*m3,Q),Q);
	m3=m2; m2=m1; m1=xar;
end